package de.hsh.dbs2.imdb.logic;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import de.hsh.dbs2.imdb.records.ConnectionManager;
import de.hsh.dbs2.imdb.records.Genre;

public class GenreManager {

	/**
	 * Ermittelt eine vollstaendige Liste aller in der Datenbank abgelegten Genres
	 * Die Genres werden alphabetisch sortiert zurueckgeliefert.
	 * @return Alle Genre-Namen als String-Liste
	 * @throws Exception
	 */
	public List<String> getGenres() throws Exception {
		try {			
			ArrayList<String> genres = new ArrayList<String>();
			
			for (Genre genre : Genre.findAll()) {
				genres.add(genre.getGenre());
			}
			
			ConnectionManager.commit();
			return genres;
			
		} catch (SQLException e) {
			ConnectionManager.rollback();
			throw e;
		}
	}

}
