package de.hsh.dbs2.imdb.logic;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import de.hsh.dbs2.imdb.records.ConnectionManager;
import de.hsh.dbs2.imdb.records.Person;

public class PersonManager {

	/**
	 * Liefert eine Liste aller Personen, deren Name den Suchstring enthaelt.
	 * @param text Suchstring
	 * @return Liste mit passenden Personennamen, die in der Datenbank eingetragen sind.
	 * @throws Exception
	 */
	public List<String> getPersonList(String text) throws Exception {
		try {			
			ArrayList<String> personen = new ArrayList<String>();
			
			for (Person person : Person.findAll()) {
				if (person.getName().toLowerCase().indexOf(text.toLowerCase()) == -1) continue;
				
				personen.add(person.getName());
			}
			
			ConnectionManager.commit();
			return personen;
			
		} catch (SQLException e) {
			ConnectionManager.rollback();
			throw e;
		}
	}

}
