package de.hsh.dbs2.imdb.records;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class Counter {
	
	private String tableName;
	private long counter = 0;
	
	public Counter(String tableName, long counter) {
		this.tableName = tableName;
		this.counter = counter;
	}
	
	public static Counter get(String tableName) throws SQLException {
		String sql = "SELECT * FROM `Counter` WHERE `TableName`=?";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setString(1, tableName);
			try (ResultSet rs = ps.executeQuery()) {
				if (!rs.isBeforeFirst()) {
					Counter c = new Counter(tableName, 0);
					c.insert();
					return c;
				}
				return new Counter(rs.getString("TableName"), rs.getLong("Counter"));
			}
		}
	}
	
	private void insert() throws SQLException {
		String sql = "INSERT INTO `Counter` VALUES (?, ?);";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setString(1,  this.tableName);
			ps.setLong(2,  this.counter);
			ps.executeUpdate();
		}
	}
	
	public long next() throws SQLException {
		++this.counter;
		String sql = "UPDATE `Counter` SET `Counter`=? WHERE `TableName`=?";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1, this.counter);
			ps.setString(2, this.tableName);
			ps.executeUpdate();
		}
		return this.counter - 1;
	}
}
