package de.hsh.dbs2.imdb.records;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

public class MovieGenre implements ActiveRecord {
	private long movieId;
	private long genreId;
	
	public MovieGenre(long movieId, long genreId) {
		this.movieId = movieId;
		this.genreId = genreId;
	}
	
	public long getMovieID() {
		return movieId;
	}

	public long getGenreID() {
		return genreId;
	}

	@Override
	public String toString() {
		return "MovieGenre: " + this.movieId + " : " + this.genreId;
	}

	@Override
	public void insert() throws SQLException {
		String sql = "INSERT INTO `MovieGenre` VALUES (?, ?);";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1,  this.movieId);
			ps.setLong(2,  this.genreId);
			ps.executeUpdate();
		}	
	}

	@Override
	public void update() throws SQLException {
		// Ungenutzt
	}

	@Override
	public void delete() throws SQLException {
		String sql = "DELETE FROM `MovieGenre` WHERE `MovieID`=? AND `GenreID`=?";
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1,  this.movieId);
			ps.setLong(2,  this.genreId);
			ps.executeUpdate();
		}
	}
	
	public static ArrayList<MovieGenre> findAll() throws SQLException {
		String sql = "SELECT * FROM `MovieGenre`";
		ArrayList<MovieGenre> movieGenres = new ArrayList<MovieGenre>();
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			try (ResultSet rs = ps.executeQuery()) {
				int i = 0;
				while (rs.next()) {
					movieGenres.add(new MovieGenre(rs.getLong("MovieID"), rs.getLong("GenreID")));
				}
			}
		}
		return movieGenres;
	}
	
	public static ArrayList<MovieGenre> findByMovieID(long movieId) throws SQLException {
		String sql = "SELECT * FROM `MovieGenre` WHERE `MovieID`=?";
		ArrayList<MovieGenre> movieGenres = new ArrayList<MovieGenre>();
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1, movieId);
			try (ResultSet rs = ps.executeQuery()) {
				int i = 0;
				while (rs.next()) {
					movieGenres.add(new MovieGenre(rs.getLong("MovieID"), rs.getLong("GenreID")));
				}
			}
		}
		return movieGenres;
	}
	
	public static ArrayList<MovieGenre> findByGenreID(long genreId) throws SQLException {
		String sql = "SELECT * FROM `MovieGenre` WHERE `GenreID`=?";
		ArrayList<MovieGenre> movieGenres = new ArrayList<MovieGenre>();
		try (PreparedStatement ps = ConnectionManager.getConnection().prepareStatement(sql)) {
			ps.setLong(1, genreId);
			try (ResultSet rs = ps.executeQuery()) {
				int i = 0;
				while (rs.next()) {
					movieGenres.add(new MovieGenre(rs.getLong("MovieID"), rs.getLong("GenreID")));
				}
			}
		}
		return movieGenres;
	}
	
	
}
